commit 7fbab3afca910c055676ebc566bf87c4d5a7372f
Author: Harald Anlauf <anlauf@gmx.de>
Date:   Fri Sep 17 21:45:33 2021

    Fortran - (large) arrays in the main shall be static
    
    gcc/fortran/ChangeLog:
    
            PR fortran/102366
            * trans-decl.c (gfc_finish_var_decl): Disable the warning message
            for variables moved from stack to static storange if they are
            declared in the main, but allow the move to happen.
    
    gcc/testsuite/ChangeLog:
    
            PR fortran/102366
            * gfortran.dg/pr102366.f90: New test.
    
    (cherry picked from commit 51166eb2c534692c3c7779def24f83c8c3811b98)

diff --git a/gcc/fortran/trans-decl.c b/gcc/fortran/trans-decl.c
index ef307af595e..beea2e4d80b 100644
--- a/gcc/fortran/trans-decl.c
+++ b/gcc/fortran/trans-decl.c
@@ -738,7 +738,6 @@ gfc_finish_var_decl (tree decl, gfc_symbol * sym)
 
   /* Keep variables larger than max-stack-var-size off stack.  */
   if (!(sym->ns->proc_name && sym->ns->proc_name->attr.recursive)
-      && !(sym->ns->proc_name && sym->ns->proc_name->attr.is_main_program)
       && !sym->attr.automatic
       && sym->attr.save != SAVE_EXPLICIT
       && sym->attr.save != SAVE_IMPLICIT
@@ -752,7 +751,9 @@ gfc_finish_var_decl (tree decl, gfc_symbol * sym)
 	  || sym->attr.allocatable)
       && !DECL_ARTIFICIAL (decl))
     {
-      if (flag_max_stack_var_size > 0)
+      if (flag_max_stack_var_size > 0
+	  && !(sym->ns->proc_name
+	       && sym->ns->proc_name->attr.is_main_program))
 	gfc_warning (OPT_Wsurprising,
 		     "Array %qs at %L is larger than limit set by "
 		     "%<-fmax-stack-var-size=%>, moved from stack to static "
diff --git a/gcc/testsuite/gfortran.dg/pr102366.f90 b/gcc/testsuite/gfortran.dg/pr102366.f90
new file mode 100644
index 00000000000..d002f64a8ae
--- /dev/null
+++ b/gcc/testsuite/gfortran.dg/pr102366.f90
@@ -0,0 +1,9 @@
+! { dg-do compile }
+! { dg-options "-fdump-tree-original -Wall" }
+! { dg-final { scan-tree-dump-times "static real" 1 "original" } }
+! PR fortran/102366 - large arrays no longer become static
+
+program p
+  real(kind=4) :: a(16776325)
+  a=1.0
+end

